import es, playerlib, popuplib, cPickle, os, string

info = es.AddonInfo() 
info['name']        = "JTmulti" 
info['version']     = "0.1" 
info['author']      = "JT aka joshtrav" 
info['description'] = "User created multi menu to consolidate binds into one" 

es.ServerVar('jtmulti_version', info['version'], 'JTmulti by JT aka joshtrav').makepublic()

def load():
	global jtmulti_db
	jtmulti_db = {}
	jtmulti_data = es.getAddonPath('jtmulti') + '/multi_bind.db'
	if os.path.isfile(jtmulti_data):
		jtmulti_run = open(jtmulti_data)
		jtmulti_db = cPickle.load(jtmulti_run)
		jtmulti_run.close()
	if not es.exists('clientcommand', 'jtmulti'):
		es.regclientcmd('jtmulti', 'jtmulti/jtmulti_mainmenu', 'none')
	if not es.exists('saycommand', 'jtmulti'):
		es.regsaycmd('jtmulti', 'jtmulti/jtmulti_mainmenu', 'none')
	es.addons.registerSayFilter(jtmulti_say_parse)
  
def unload():
	es.unregsaycmd('jtmulti')
	es.unregclientcmd('jtmulti')
	es.addons.unregisterSayFilter(jtmulti_say_parse)
	
def player_activate(ev):
	userid = int(ev['userid'])
	steamid = playerlib.getPlayer(userid).get('steamid')
	if not jtmulti_db.has_key(steamid):
		jtmulti_db[steamid] = {}
		jtmulti_db[steamid]['Total_Commands'] = 0
		jtmulti_db[steamid]['Add_Step'] = 0
		jtmulti_db[steamid]['Command'] = {}
		jtmulti_db[steamid]['Command_Name'] = {}
		jtmulti_db[steamid]['Command_Type'] = {}

def jtmulti_mainmenu():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	jtmulti_mainmenu = popuplib.easymenu('JT Multi Command', '_popup_choice', jtmulti_mainmenu_select)
	if jtmulti_db[steamid]['Total_Commands'] > 0:
		jtmulti_count = 1
		while jtmulti_count <= jtmulti_db[steamid]['Total_Commands']:
			jtmulti_mainmenu.addoption(jtmulti_count,jtmulti_db[steamid]['Command_Name'][jtmulti_count])
			jtmulti_count += 1
		jtmulti_mainmenu.addoption('Remove a command','Remove a command')
	jtmulti_mainmenu.addoption('Add a command','Add a command')
	jtmulti_mainmenu.send(userid)
	
def jtmulti_mainmenu_select(userid, choice, popupid):
	popuplib.unsend('JT Multi Command', userid)
	if choice == 'Add a command':
		jtmulti_addmenu = popuplib.easymenu('What type of command', '_popup_choice', jtmulti_addmenu_select)
		jtmulti_addmenu.addoption('Say command','Say command')
		jtmulti_addmenu.addoption('Console command','Console command')
		jtmulti_addmenu.send(userid)
	elif choice == 'Remove a command':
		jtmulti_remove_command(userid)
	else:
		jtmulti_run_cmd(userid,choice)

def jtmulti_run_cmd(userid,choice):
	steamid = playerlib.getPlayer(userid).get('steamid')
	if jtmulti_db[steamid]['Command_Type'][choice] == 'Say':
		es.sexec(userid, 'say %s'%jtmulti_db[steamid]['Command'][choice])
	else:
		es.cexec(userid, jtmulti_db[steamid]['Command'][choice])
		

def jtmulti_addmenu_select(userid, choice, popupid):
	popuplib.unsend('What type of command?', userid)
	steamid = playerlib.getPlayer(userid).get('steamid')
	jtmulti_db[steamid]['Total_Commands'] += 1
	if choice == 'Console command':
		jtmulti_db[steamid]['Command_Type'][jtmulti_db[steamid]['Total_Commands']] = 'Console'
	else:
		jtmulti_db[steamid]['Command_Type'][jtmulti_db[steamid]['Total_Commands']] = 'Say'
	es.tell(userid, '#multi', '#green[JT Multi]#lightgreen Enter the command information in say chat please.')
	es.tell(userid, '#multi', '#green[JT Multi]#lightgreen Example: ManiAdmin admin. Do not use more then one space.')
	jtmulti_db[steamid]['Add_Step'] = 1
	
		
def jtmulti_say_parse(userid, fulltext, team):
	steamid = playerlib.getPlayer(userid).get('steamid')
	global jtmulti_db
	if jtmulti_db.has_key(steamid):
		if jtmulti_db[steamid]['Add_Step'] == 1:
			fulltext=fulltext.replace('"','')
			jtmulti_commands = fulltext.split(' ', 1)
			fulltext = ''
			jtmulti_db[steamid]['Command_Name'][jtmulti_db[steamid]['Total_Commands']] = jtmulti_commands[0]
			jtmulti_db[steamid]['Command'][jtmulti_db[steamid]['Total_Commands']] = jtmulti_commands[1]
			jtmulti_db[steamid]['Add_Step'] = 0
			es.tell(userid, '#multi', '#green[JT Multi]#default Added menu item #lightgreen%s #defaultto run command #lightgreen%s#default.'%(jtmulti_db[steamid]['Command_Name'][jtmulti_db[steamid]['Total_Commands']],jtmulti_db[steamid]['Command'][jtmulti_db[steamid]['Total_Commands']]))
			jtmulti_save_db()
	return userid, fulltext, team

def jtmulti_save_db():
	jtmulti_data = open(es.getAddonPath('jtmulti') + '/multi_bind.db', 'w')
	cPickle.dump(jtmulti_db,jtmulti_data)
	jtmulti_data.close()
	
def jtmulti_remove_command(userid):
	steamid = playerlib.getPlayer(userid).get('steamid')
	jtmulti_removemenu = popuplib.easymenu('Pick command to remove', '_popup_choice', jtmulti_remove_select)
	jtmulti_count = 1
	while jtmulti_count <= jtmulti_db[steamid]['Total_Commands']:
		jtmulti_removemenu.addoption(jtmulti_count,jtmulti_db[steamid]['Command_Name'][jtmulti_count])
		jtmulti_count += 1
	jtmulti_removemenu.send(userid)
		
def jtmulti_remove_select(userid, choice, popupid):
	popuplib.unsend('Pick command to remove', userid)
	steamid = playerlib.getPlayer(userid).get('steamid')
	if choice == jtmulti_db[steamid]['Total_Commands']:
		es.tell(userid, '#multi', '#green[JT Multi]#default Removed menu item #lightgreen%s #defaultto run command #lightgreen%s#default.'%(jtmulti_db[steamid]['Command_Name'][jtmulti_db[steamid]['Total_Commands']],jtmulti_db[steamid]['Command'][jtmulti_db[steamid]['Total_Commands']]))
		jtmulti_db[steamid]['Total_Commands'] -= 1
		for jtmulti_dict_type in ('Command','Command_Name','Command_Type'):
			del jtmulti_db[steamid][jtmulti_dict_type][choice]
	else:
		jtmulti_count = choice
		while jtmulti_count < jtmulti_db[steamid]['Total_Commands']:
			jtmulti_upcount = jtmulti_count + 1
			for jtmulti_dict_type in ('Command','Command_Name','Command_Type'):
				jtmulti_db[steamid][jtmulti_dict_type][jtmulti_count] = jtmulti_db[steamid][jtmulti_dict_type][jtmulti_upcount]
			jtmulti_count += 1
		es.tell(userid, '#multi', '#green[JT Multi]#default Removed menu item #lightgreen%s #defaultto run command #lightgreen%s#default.'%(jtmulti_db[steamid]['Command_Name'][choice],jtmulti_db[steamid]['Command'][choice]))
		for jtmulti_dict_type in ('Command','Command_Name','Command_Type'):
			del jtmulti_db[steamid][jtmulti_dict_type][jtmulti_db[steamid]['Total_Commands']]
		jtmulti_db[steamid]['Total_Commands'] -= 1
	jtmulti_save_db()
	
def round_start(ev):
	es.msg('#multi', '#green[JT Multi]#default Type jtmulti for multi command personal menu')
	